Index: /extensions/NBC_UserAdvManager/branches/2.15/ConfirmMail.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/ConfirmMail.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/ConfirmMail.php	(revision 6776)
@@ -14,15 +14,4 @@
 load_language('plugin.lang', UAM_PATH);
 
-/**
- * set in ./language/en_UK.iso-8859-1/local.lang.php (maybe to create)
- * for example for clear theme:
-  $lang['Theme: clear'] = 'This is the clear theme based on yoga template. '.
-  ' A standard template/theme of PhpWebgallery.';
- *
- * Don't forget php tags !!!
- *
- * Another way is to code it thru the theme itself in ./themeconf.inc.php
- */
-
 $title= l10n('confirm_mail_page_title');
 $page['body_id'] = 'theAboutPage';
@@ -31,4 +20,5 @@
 @include(PHPWG_ROOT_PATH.'template/'.$user['template'].
   '/theme/'.$user['theme'].'/themeconf.inc.php');
+
 
 if (isset($_GET['key']))
Index: /extensions/NBC_UserAdvManager/branches/2.15/admin/UAM_admin.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/admin/UAM_admin.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/admin/UAM_admin.php	(revision 6776)
@@ -28,5 +28,4 @@
 $UAM_Password_Test_Score = 0;
 $UAM_Exclusionlist_Error = false;
-
 
 // +-----------------------------------------------------------------------+
@@ -102,13 +101,13 @@
   case 'global':
 
-	if (isset($_POST['submit']) and !is_adviser() and isset($_POST['UAM_Mail_Info']) and isset($_POST['UAM_No_Casse']) and isset($_POST['UAM_Username_Char']) and isset($_POST['UAM_Confirm_Mail']) and isset($_POST['UAM_No_Comment_Anonymous']) and isset($_POST['UAM_Password_Enforced']) and isset($_POST['UAM_AdminPassword_Enforced']) and isset($_POST['UAM_GhostUser_Tracker']) and isset($_POST['UAM_Admin_ConfMail']))
+	if (isset($_POST['submit']) and !is_adviser() and isset($_POST['UAM_Mail_Info']) and isset($_POST['UAM_Username_Char']) and isset($_POST['UAM_Confirm_Mail']) and isset($_POST['UAM_No_Comment_Anonymous']) and isset($_POST['UAM_Password_Enforced']) and isset($_POST['UAM_AdminPassword_Enforced']) and isset($_POST['UAM_GhostUser_Tracker']) and isset($_POST['UAM_Admin_ConfMail']) and isset($_POST['UAM_RedirToProfile']))
   {
 
 /* General configuration settings */
-		$_POST['UAM_MailInfo_Text'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_MailInfo_Text']));
+		$_POST['UAM_MailInfo_Text'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_MailInfo_Text'])));
     
-		$_POST['UAM_ConfirmMail_Text'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Text']));
-
-    $_POST['UAM_GhostTracker_ReminderText'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_GhostTracker_ReminderText']));
+		$_POST['UAM_ConfirmMail_Text'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Text'])));
+
+    $_POST['UAM_GhostTracker_ReminderText'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_GhostTracker_ReminderText'])));
 
 
@@ -119,8 +118,7 @@
       $UAM_Exclusionlist_Error = true;
     }
-		
+
 		$newconf_UAM = array(
       $_POST['UAM_Mail_Info'],
-      $_POST['UAM_No_Casse'],
       $_POST['UAM_Confirm_Mail'],
       (isset($_POST['UAM_No_Confirm_Group'])?$_POST['UAM_No_Confirm_Group']:''),
@@ -142,5 +140,6 @@
       $_POST['UAM_GhostTracker_ReminderText'],
       $_POST['UAM_Add_LastVisit_Column'],
-      $_POST['UAM_Admin_ConfMail']);
+      $_POST['UAM_Admin_ConfMail'],
+      $_POST['UAM_RedirToProfile']);
 
     $conf['UserAdvManager'] = serialize($newconf_UAM);
@@ -155,15 +154,13 @@
 		pwg_query($query);
 
-
 /* Email confirmation settings */
-    $_POST['UAM_ConfirmMail_ReMail_Txt1'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_ReMail_Txt1']));
-
-    $_POST['UAM_ConfirmMail_ReMail_Txt2'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_ReMail_Txt2']));
+    $_POST['UAM_ConfirmMail_ReMail_Txt1'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_ReMail_Txt1'])));
+
+    $_POST['UAM_ConfirmMail_ReMail_Txt2'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_ReMail_Txt2'])));
     
-    $_POST['UAM_ConfirmMail_Custom_Txt1'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Custom_Txt1']));
+    $_POST['UAM_ConfirmMail_Custom_Txt1'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Custom_Txt1'])));
     
-    $_POST['UAM_ConfirmMail_Custom_Txt2'] = str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Custom_Txt2']));
-
-
+    $_POST['UAM_ConfirmMail_Custom_Txt2'] = str_replace('\"', '"', str_replace("\'", "'", str_replace("\\\\", "\\", $_POST['UAM_ConfirmMail_Custom_Txt2'])));
+    
 	  $newconf_UAM_ConfirmMail = array (
       $_POST['UAM_ConfirmMail_TimeOut'],
@@ -220,10 +217,10 @@
     $groups[$row['id']] = $row['name'];
 /* configuration value for unvalidated users */
+    if (isset($conf_UAM[2]) and $conf_UAM[2] == $row['id'])
+    {
+	  	$No_Valid = $row['id'];
+		}
+/* configuration value for validated users */
     if (isset($conf_UAM[3]) and $conf_UAM[3] == $row['id'])
-    {
-	  	$No_Valid = $row['id'];
-		}
-/* configuration value for validated users */
-    if (isset($conf_UAM[4]) and $conf_UAM[4] == $row['id'])
 		{
 	  	$Valid = $row['id'];
@@ -257,5 +254,5 @@
   {
 	  $status_options[$status] = l10n('user_status_'.$status);
-	  if (isset($conf_UAM[9]) and $conf_UAM[9] == $status)
+	  if (isset($conf_UAM[8]) and $conf_UAM[8] == $status)
 	  {
 	    $No_Valid_Status = $status;
@@ -276,5 +273,5 @@
   {
 	  $status_options[$status] = l10n('user_status_'.$status);
-	  if (isset($conf_UAM[5]) and $conf_UAM[5] == $status)
+	  if (isset($conf_UAM[4]) and $conf_UAM[4] == $status)
 		{
 		  $Valid_Status = $status;
@@ -305,35 +302,36 @@
 		'UAM_MAIL_INFO_TRUE'             => $conf_UAM[0]=='true' ?  'checked="checked"' : '' ,
 		'UAM_MAIL_INFO_FALSE'            => $conf_UAM[0]=='false' ?  'checked="checked"' : '' ,
-		'UAM_MAILINFO_TEXT'              => $conf_UAM[10],
-		'UAM_NO_CASSE_TRUE'              => $conf_UAM[1]=='true' ?  'checked="checked"' : '' ,
-		'UAM_NO_CASSE_FALSE'             => $conf_UAM[1]=='false' ?  'checked="checked"' : '' ,
-		'UAM_USERNAME_CHAR_TRUE'         => $conf_UAM[7]=='true' ?  'checked="checked"' : '' ,
-		'UAM_USERNAME_CHAR_FALSE'        => $conf_UAM[7]=='false' ?  'checked="checked"' : '' ,
-		'UAM_USERNAME_CHAR_LIST'         => $conf_UAM[8],
-		'UAM_CONFIRM_MAIL_TRUE'          => $conf_UAM[2]=='true' ?  'checked="checked"' : '' ,
-		'UAM_CONFIRM_MAIL_FALSE'         => $conf_UAM[2]=='false' ?  'checked="checked"' : '' ,
-		'UAM_CONFIRMMAIL_TEXT'           => $conf_UAM[11],
-		'UAM_No_Confirm_Group'           => $conf_UAM[3],
-		'UAM_Validated_Group'            => $conf_UAM[4],
-		'UAM_No_Confirm_Status'          => $conf_UAM[9],
-		'UAM_Validated_Status'           => $conf_UAM[5],
-		'UAM_NO_COMMENT_ANO_TRUE'        => $conf_UAM[6]=='true' ?  'checked="checked"' : '' ,
-		'UAM_NO_COMMENT_ANO_FALSE'       => $conf_UAM[6]=='false' ?  'checked="checked"' : '' ,
-		'UAM_MAILEXCLUSION_TRUE'         => $conf_UAM[12]=='true' ?  'checked="checked"' : '' ,
-		'UAM_MAILEXCLUSION_FALSE'        => $conf_UAM[12]=='false' ?  'checked="checked"' : '' ,
-		'UAM_MAILEXCLUSION_LIST'         => $conf_UAM[13],
-		'UAM_PASSWORDENF_TRUE'           => $conf_UAM[14]=='true' ?  'checked="checked"' : '' ,
-		'UAM_PASSWORDENF_FALSE'          => $conf_UAM[14]=='false' ?  'checked="checked"' : '' ,
-		'UAM_PASSWORD_SCORE'             => $conf_UAM[15],
-    'UAM_ADMINPASSWENF_TRUE'         => $conf_UAM[16]=='true' ?  'checked="checked"' : '' ,
-		'UAM_ADMINPASSWENF_FALSE'        => $conf_UAM[16]=='false' ?  'checked="checked"' : '' ,
-    'UAM_GHOSTRACKER_TRUE'           => $conf_UAM[17]=='true' ?  'checked="checked"' : '' ,
-		'UAM_GHOSTRACKER_FALSE'          => $conf_UAM[17]=='false' ?  'checked="checked"' : '' ,
-    'UAM_GHOSTRACKER_DAYLIMIT'       => $conf_UAM[18],
-    'UAM_GHOSTRACKER_REMINDERTEXT'   => $conf_UAM[19],
-    'UAM_ADDLASTVISIT_TRUE'          => $conf_UAM[20]=='true' ?  'checked="checked"' : '' ,
-    'UAM_ADDLASTVISIT_FALSE'         => $conf_UAM[20]=='false' ?  'checked="checked"' : '' ,
-    'UAM_ADMINCONFMAIL_TRUE'         => $conf_UAM[21]=='true' ?  'checked="checked"' : '' ,
-    'UAM_ADMINCONFMAIL_FALSE'        => $conf_UAM[21]=='false' ?  'checked="checked"' : '' ,
+		'UAM_MAILINFO_TEXT'              => $conf_UAM[9],
+		'UAM_USERNAME_CHAR_TRUE'         => $conf_UAM[6]=='true' ?  'checked="checked"' : '' ,
+		'UAM_USERNAME_CHAR_FALSE'        => $conf_UAM[6]=='false' ?  'checked="checked"' : '' ,
+		'UAM_USERNAME_CHAR_LIST'         => $conf_UAM[7],
+		'UAM_CONFIRM_MAIL_TRUE'          => $conf_UAM[1]=='true' ?  'checked="checked"' : '' ,
+		'UAM_CONFIRM_MAIL_FALSE'         => $conf_UAM[1]=='false' ?  'checked="checked"' : '' ,
+    'UAM_CONFIRM_MAIL_LOCAL'         => $conf_UAM[1]=='local' ?  'checked="checked"' : '' ,
+		'UAM_CONFIRMMAIL_TEXT'           => $conf_UAM[10],
+		'UAM_No_Confirm_Group'           => $conf_UAM[2],
+		'UAM_Validated_Group'            => $conf_UAM[3],
+		'UAM_No_Confirm_Status'          => $conf_UAM[8],
+		'UAM_Validated_Status'           => $conf_UAM[4],
+		'UAM_NO_COMMENT_ANO_TRUE'        => $conf_UAM[5]=='true' ?  'checked="checked"' : '' ,
+		'UAM_NO_COMMENT_ANO_FALSE'       => $conf_UAM[5]=='false' ?  'checked="checked"' : '' ,
+		'UAM_MAILEXCLUSION_TRUE'         => $conf_UAM[11]=='true' ?  'checked="checked"' : '' ,
+		'UAM_MAILEXCLUSION_FALSE'        => $conf_UAM[11]=='false' ?  'checked="checked"' : '' ,
+		'UAM_MAILEXCLUSION_LIST'         => $conf_UAM[12],
+		'UAM_PASSWORDENF_TRUE'           => $conf_UAM[13]=='true' ?  'checked="checked"' : '' ,
+		'UAM_PASSWORDENF_FALSE'          => $conf_UAM[13]=='false' ?  'checked="checked"' : '' ,
+		'UAM_PASSWORD_SCORE'             => $conf_UAM[14],
+    'UAM_ADMINPASSWENF_TRUE'         => $conf_UAM[15]=='true' ?  'checked="checked"' : '' ,
+		'UAM_ADMINPASSWENF_FALSE'        => $conf_UAM[15]=='false' ?  'checked="checked"' : '' ,
+    'UAM_GHOSTRACKER_TRUE'           => $conf_UAM[16]=='true' ?  'checked="checked"' : '' ,
+		'UAM_GHOSTRACKER_FALSE'          => $conf_UAM[16]=='false' ?  'checked="checked"' : '' ,
+    'UAM_GHOSTRACKER_DAYLIMIT'       => $conf_UAM[17],
+    'UAM_GHOSTRACKER_REMINDERTEXT'   => $conf_UAM[18],
+    'UAM_ADDLASTVISIT_TRUE'          => $conf_UAM[19]=='true' ?  'checked="checked"' : '' ,
+    'UAM_ADDLASTVISIT_FALSE'         => $conf_UAM[19]=='false' ?  'checked="checked"' : '' ,
+    'UAM_ADMINCONFMAIL_TRUE'         => $conf_UAM[20]=='true' ?  'checked="checked"' : '' ,
+    'UAM_ADMINCONFMAIL_FALSE'        => $conf_UAM[20]=='false' ?  'checked="checked"' : '' ,
+    'UAM_REDIRTOPROFILE_TRUE'        => $conf_UAM[21]=='true' ?  'checked="checked"' : '' ,
+    'UAM_REDIRTOPROFILE_FALSE'       => $conf_UAM[21]=='false' ?  'checked="checked"' : '' ,
 		'UAM_PASSWORD_TEST_SCORE'        => $UAM_Password_Test_Score,
     'UAM_ERROR_REPORTS4'             => $UAM_Exclusionlist_Error,
@@ -355,5 +353,5 @@
 		
 /* username insensible a la casse */
-    if (isset($conf_UAM[3]) and $conf_UAM[3] == 'true')
+    if (isset($conf_UAM[2]) and $conf_UAM[2] == 'true')
 	  {
 			$query = "
@@ -379,5 +377,5 @@
 		
 /* Username without forbidden keys */
-    if ( isset($conf_UAM[7]) and $conf_UAM[7] == 'true' )
+    if ( isset($conf_UAM[6]) and $conf_UAM[6] == 'true' )
 	  {
 			$query = "
@@ -398,5 +396,5 @@
 		
 /* Email without forbidden domain */
-    if ( isset($conf_UAM[12]) and $conf_UAM[12] == 'true' )
+    if ( isset($conf_UAM[11]) and $conf_UAM[11] == 'true' )
 	  {
 			$query = "
@@ -409,5 +407,5 @@
 		  while($row = pwg_db_fetch_assoc($result))
 		  {
-			  $conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM[13]);
+			  $conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM[12]);
 			  for ($i = 0 ; $i < count($conf_MailExclusion) ; $i++)
 			  {
@@ -467,5 +465,5 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
   
-  if (isset($conf_UAM[20]) and $conf_UAM[20]=='true')
+  if (isset($conf_UAM[19]) and $conf_UAM[19]=='true')
   {
 // +-----------------------------------------------------------------------+
@@ -495,5 +493,5 @@
 // |                           Template Init                               |
 // +-----------------------------------------------------------------------+
-		$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
+		/*$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
 
     if (isset($_GET['start']) and is_numeric($_GET['start']))
@@ -504,5 +502,5 @@
     {
       $start = 0;
-    }
+    }*/
 
 // +-----------------------------------------------------------------------+
@@ -510,5 +508,5 @@
 // +-----------------------------------------------------------------------+
 
-$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
+/*$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
 
 $navbar = create_navigation_bar(
@@ -519,5 +517,5 @@
   );
 
-$template->assign('navbar', $navbar);
+$template->assign('navbar', $navbar);*/
 
 // +-----------------------------------------------------------------------+
@@ -528,6 +526,6 @@
     foreach ($page['filtered_users'] as $num => $local_user)
     {
-/* simulate LIMIT $start, $conf['users_page'] */
-			if ($num < $start)
+// simulate LIMIT $start, $conf['users_page']
+			/*if ($num < $start)
       {
         continue;
@@ -536,5 +534,5 @@
       {
         break;
-      }
+      }*/
 
       $visible_user_list[] = $local_user;
@@ -555,17 +553,17 @@
       $deltadays = floor($deltasecs / 86400);// Convert result from seconds to days
       
-      if (isset($conf_UAM[17]) and $conf_UAM[17]=='true' and $conf_UAM[18] <> '')
+      if (isset($conf_UAM[16]) and $conf_UAM[16]=='true' and $conf_UAM[17] <> '')
       {
-        if ($deltadays <= ($conf_UAM[18]/2))
+        if ($deltadays <= ($conf_UAM[17]/2))
         {
           $display = 'green';
         }
         
-        if (($deltadays > ($conf_UAM[18]/2)) and ($deltadays < $conf_UAM[18]))
+        if (($deltadays > ($conf_UAM[17]/2)) and ($deltadays < $conf_UAM[17]))
         {
           $display = 'orange';
         }
         
-        if ($deltadays >= $conf_UAM[18])
+        if ($deltadays >= $conf_UAM[17])
         {
           $display = 'red';
@@ -629,6 +627,6 @@
   $conf_UAM_ConfirmMail = unserialize($conf['UserAdvManager_ConfirmMail']);
 	
-  if (isset($conf_UAM[2]) and $conf_UAM[2]=='true' and ((isset($conf_UAM[3]) and $conf_UAM[3] <> '-1') or (isset($conf_UAM[9]) and $conf_UAM[9] <> '-1')) and isset($conf_UAM_ConfirmMail[0]) and $conf_UAM_ConfirmMail[0]=='true')
-  {
+  if (isset($conf_UAM[1]) and ($conf_UAM[1]=='true' or $conf_UAM[1]=='local') and ((isset($conf_UAM[2]) and $conf_UAM[2] <> '-1') or (isset($conf_UAM[8]) and $conf_UAM[8] <> '-1')))
+  {   
 // +-----------------------------------------------------------------------+
 // |                           initialization                              |
@@ -1009,5 +1007,5 @@
 // |                           Template Init                               |
 // +-----------------------------------------------------------------------+
-		$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
+		/*$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
 
     if (isset($_GET['start']) and is_numeric($_GET['start']))
@@ -1018,5 +1016,5 @@
     {
       $start = 0;
-    }
+    }*/
 
 /* Hide radio-button if not allow to assign adviser */
@@ -1030,5 +1028,5 @@
 // +-----------------------------------------------------------------------+
 
-$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
+/*$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
 
 $navbar = create_navigation_bar(
@@ -1039,5 +1037,5 @@
   );
 
-$template->assign('navbar', $navbar);
+$template->assign('navbar', $navbar);*/
 
 // +-----------------------------------------------------------------------+
@@ -1052,5 +1050,5 @@
     {
 /* simulate LIMIT $start, $conf['users_page'] */
-			if ($num < $start)
+			/*if ($num < $start)
       {
         continue;
@@ -1059,5 +1057,5 @@
       {
         break;
-      }
+      }*/
 
       $visible_user_list[] = $local_user;
@@ -1115,5 +1113,5 @@
 
 			$expiration = expiration($local_user['id']);
-
+      
    		$template->append(
      		'users',
@@ -1138,8 +1136,23 @@
 				)
 			);
-		}
+		}   
+
+    // Check if validation of register is made by admin or visitor 
+    // If visitor, $Confirm_Local is used to mask useless buttons
+    $Confirm_Local = "";
+    
+    if ($conf_UAM[1] == 'local')
+    {
+      $Confirm_Local = $conf_UAM[1];
+    }
+    else
+    {
+      $Confirm_Local = "";
+    } 
+    
     /* Plugin version inserted */
     $template->assign(
       array(
+        'CONFIRM_LOCAL'=> $Confirm_Local,
         'UAM_VERSION'  => $version,
         'UAM_PATH'     => UAM_PATH,
@@ -1181,5 +1194,5 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
 	
-  if (isset($conf_UAM[17]) and $conf_UAM[17]=='true')
+  if (isset($conf_UAM[16]) and $conf_UAM[16]=='true')
   {
 // +-----------------------------------------------------------------------+
@@ -1443,5 +1456,5 @@
 // |                           Template Init                               |
 // +-----------------------------------------------------------------------+
-		$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
+		/*$base_url = PHPWG_ROOT_PATH.'admin.php?page=user_list';
 
     if (isset($_GET['start']) and is_numeric($_GET['start']))
@@ -1452,5 +1465,5 @@
     {
       $start = 0;
-    }
+    }*/
 
 /* Hide radio-button if not allow to assign adviser */
@@ -1464,5 +1477,5 @@
 // +-----------------------------------------------------------------------+
 
-$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
+/*$url = PHPWG_ROOT_PATH.'admin.php'.get_query_string_diff(array('start'));
 
 $navbar = create_navigation_bar(
@@ -1473,5 +1486,5 @@
   );
 
-$template->assign('navbar', $navbar);
+$template->assign('navbar', $navbar);*/
 
 // +-----------------------------------------------------------------------+
@@ -1483,5 +1496,5 @@
     {
 /* simulate LIMIT $start, $conf['users_page'] */
-			if ($num < $start)
+			/*if ($num < $start)
       {
         continue;
@@ -1490,5 +1503,5 @@
       {
         break;
-      }
+      }*/
 
       $visible_user_list[] = $local_user;
Index: /extensions/NBC_UserAdvManager/branches/2.15/changelog.txt.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/changelog.txt.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/changelog.txt.php	(revision 6776)
@@ -174,5 +174,15 @@
             Bug 1655 fixed - Navigation bar is usefull again
             
--- 2.15.3 : Quick update to fix a database upgrade issue 
+-- 2.15.3 : Quick update to fix a database upgrade issue
+
+-- 2.15.4 : Bug 1310 fixed - UAM tables are now sortable
+            Bug 1656 fixed - New register validation mode: Manual validation by admin
+            Bug 1687 fixed - Login case sensitivity is no more used in this plugin because already set in Piwigo's core
+            Bug 1727 partially fixed - New option to redirect users to profile page after their first login only.
+              Known problem: The redirection doesn't work after registration and after confirmation page (if ConfirmMail is enabled)
+                             The redirection applies to already registered users including admins, webmaster and generic status.
+            Bug 1789 fixed - Escaping double quotes in text fields
+            Bug 1790 fixed - Validation tracking tab is set when correct options are set
+            Bug 1795 fixed - Fixes rules using email information and/or email of validation
 */
 ?>
Index: /extensions/NBC_UserAdvManager/branches/2.15/include/functions.inc.php
===================================================================
--- /extensions/NBC_UserAdvManager/branches/2.15/include/functions.inc.php	(revision 6775)
+++ /extensions/NBC_UserAdvManager/branches/2.15/include/functions.inc.php	(revision 6776)
@@ -45,11 +45,11 @@
       $password = $password <> '' ? $password : l10n('UAM_empty_pwd');
       
-      if (isset($conf_UAM[10]) and $conf_UAM[10] <> '')
+      if (isset($conf_UAM[9]) and $conf_UAM[9] <> '')
       {
         if (function_exists('get_user_language_desc'))
         {
-          $infos1_perso = get_user_language_desc($conf_UAM[10])."\n\n";
+          $infos1_perso = get_user_language_desc($conf_UAM[9])."\n\n";
         }
-        else $infos1_perso = l10n($conf_UAM[10])."\n\n"; 
+        else $infos1_perso = l10n($conf_UAM[9])."\n\n"; 
       }
       
@@ -81,5 +81,5 @@
 
 
-  if ( isset($conf_UAM[2]) and $conf_UAM[2] == 'true' and $confirm)
+  if ( isset($conf_UAM[1]) and $conf_UAM[1] == 'true' and $confirm)
   {
     $infos2 = array
@@ -89,11 +89,11 @@
     );
 
-    if (isset($conf_UAM[11]) and $conf_UAM[11] <> '')
+    if (isset($conf_UAM[10]) and $conf_UAM[10] <> '')
     {
       if (function_exists('get_user_language_desc'))
       {
-        $infos2_perso = get_user_language_desc($conf_UAM[11])."\n\n";
+        $infos2_perso = get_user_language_desc($conf_UAM[10])."\n\n";
       }
-      else $infos2_perso = l10n($conf_UAM[11])."\n\n";
+      else $infos2_perso = l10n($conf_UAM[10])."\n\n";
     }
   }
@@ -275,13 +275,13 @@
   $subject = '['.$conf['gallery_title'].'] '.l10n_args(get_l10n_args('Ghost_reminder_of_%s', $username));     
 
-  if (isset($conf_UAM[19]) and $conf_UAM[19] <> '' and isset($conf_UAM[17]) and $conf_UAM[17] == 'true')
+  if (isset($conf_UAM[18]) and $conf_UAM[18] <> '' and isset($conf_UAM[16]) and $conf_UAM[16] == 'true')
   {
     if (function_exists('get_user_language_desc'))
     {
-      $infos1 = get_user_language_desc($conf_UAM[19])."\n\n";
+      $infos1 = get_user_language_desc($conf_UAM[18])."\n\n";
     }
     else
     {
-      $infos1 = l10n($conf_UAM[19])."\n\n";
+      $infos1 = l10n($conf_UAM[18])."\n\n";
     }
 
@@ -359,16 +359,16 @@
 WHERE user_id = '".$user_id."'
   AND (
+    group_id = '".$conf_UAM[2]."'
+  OR 
     group_id = '".$conf_UAM[3]."'
-  OR 
-    group_id = '".$conf_UAM[4]."'
   )
 ;";
     pwg_query($query);
 
-    if (!is_admin() and $conf_UAM[9] <> -1)
+    if (!is_admin() and $conf_UAM[8] <> -1)
     {
       $query = "
 UPDATE ".USER_INFOS_TABLE."
-SET status = '".$conf_UAM[9]."'
+SET status = '".$conf_UAM[8]."'
 WHERE user_id = '".$user_id."'
 ;";
@@ -376,5 +376,5 @@
     }
 
-    if ( $conf_UAM[3] <> -1 )
+    if ( $conf_UAM[2] <> -1 )
     {
       $query = "
@@ -382,5 +382,5 @@
   (user_id, group_id)
 VALUES
-  ('".$user_id."', '".$conf_UAM[3]."')
+  ('".$user_id."', '".$conf_UAM[2]."')
 ;";
       pwg_query($query);
@@ -388,4 +388,45 @@
     
     return get_absolute_root_url().UAM_PATH.'ConfirmMail.php?key='.$Confirm_Mail_ID;
+  }
+}
+
+
+/* Function called from main.inc.php to set group to new users if manual validation is set */
+function setgroup($user_id)
+{
+  global $conf;
+  
+  $conf_UAM = unserialize($conf['UserAdvManager']);
+
+  $query = "
+DELETE FROM ".USER_GROUP_TABLE."
+WHERE user_id = '".$user_id."'
+  AND (
+    group_id = '".$conf_UAM[2]."'
+  OR 
+    group_id = '".$conf_UAM[3]."'
+  )
+;";
+  pwg_query($query);
+
+  if (!is_admin() and $conf_UAM[8] <> -1)
+  {
+    $query = "
+UPDATE ".USER_INFOS_TABLE."
+SET status = '".$conf_UAM[8]."'
+WHERE user_id = '".$user_id."'
+;";
+    pwg_query($query);
+  }
+
+  if ( $conf_UAM[2] <> -1 )
+  {
+    $query = "
+INSERT INTO ".USER_GROUP_TABLE."
+  (user_id, group_id)
+VALUES
+  ('".$user_id."', '".$conf_UAM[2]."')
+;";
+    pwg_query($query);
   }
 }
@@ -457,4 +498,31 @@
   pwg_query($query);
 }
+
+
+/* Function called from main.inc.php - Triggered on user deletion */
+function DeleteRedir($user_id)
+{
+  $tab = array();
+
+  $query = "
+SELECT value
+FROM ".CONFIG_TABLE."
+WHERE param = 'UserAdvManager_Redir'
+;";
+
+  $tab = pwg_db_fetch_row(pwg_query($query));
+  
+  $values = explode(',', $tab[0]);
+
+  unset($values[array_search($user_id, $values)]);
+     
+  $query = "
+UPDATE ".CONFIG_TABLE."
+SET value = \"".implode(',', $values)."\"
+WHERE param = 'UserAdvManager_Redir';";
+
+  pwg_query($query);
+}
+
 
 /* Function called from ConfirmMail.php to verify validation key used by user according time limit */
@@ -525,15 +593,15 @@
 						pwg_query($query);
       
-						if ($conf_UAM[3] <> -1) // Delete user from unvalidated users group
+						if ($conf_UAM[2] <> -1) // Delete user from unvalidated users group
 						{
 							$query = "
 DELETE FROM ".USER_GROUP_TABLE."
 WHERE user_id = '".$data['user_id']."'
-  AND group_id = '".$conf_UAM[3]."'
+  AND group_id = '".$conf_UAM[2]."'
 ;";
 							pwg_query($query);
 						}
 	    
-						if ($conf_UAM[4] <> -1) // Add user to validated users group 
+						if ($conf_UAM[3] <> -1) // Add user to validated users group 
 						{
 							$query = "
@@ -541,14 +609,14 @@
   (user_id, group_id)
 VALUES
-  ('".$data['user_id']."', '".$conf_UAM[4]."')
+  ('".$data['user_id']."', '".$conf_UAM[3]."')
 ;";
 							pwg_query($query);
 						}
 
-						if (($conf_UAM[5] <> -1 or isset($data['status']))) // Change user's status
+						if (($conf_UAM[4] <> -1 or isset($data['status']))) // Change user's status
 						{
 							$query = "
 UPDATE ".USER_INFOS_TABLE."
-SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[5])."'
+SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[4])."'
 WHERE user_id = '".$data['user_id']."'
 ;";
@@ -577,4 +645,14 @@
 					pwg_query($query);
       
+					if ($conf_UAM[2] <> -1)
+					{
+						$query = "
+DELETE FROM ".USER_GROUP_TABLE."
+WHERE user_id = '".$data['user_id']."'
+AND group_id = '".$conf_UAM[2]."'
+;";
+						pwg_query($query);
+					}
+    
 					if ($conf_UAM[3] <> -1)
 					{
@@ -585,14 +663,4 @@
 ;";
 						pwg_query($query);
-					}
-    
-					if ($conf_UAM[4] <> -1)
-					{
-						$query = "
-DELETE FROM ".USER_GROUP_TABLE."
-WHERE user_id = '".$data['user_id']."'
-AND group_id = '".$conf_UAM[4]."'
-;";
-						pwg_query($query);
 
 						$query = "
@@ -600,14 +668,14 @@
   (user_id, group_id)
 VALUES
-  ('".$data['user_id']."', '".$conf_UAM[4]."')
+  ('".$data['user_id']."', '".$conf_UAM[3]."')
 ;";
 						pwg_query($query);
 					}
 
-					if (($conf_UAM[5] <> -1 or isset($data['status'])))
+					if (($conf_UAM[4] <> -1 or isset($data['status'])))
 					{
 						$query = "
 UPDATE ".USER_INFOS_TABLE."
-SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[5])."'
+SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[4])."'
 WHERE user_id = '".$data['user_id']."'
 ;";
@@ -662,4 +730,14 @@
 			pwg_query($query);
 	     
+			if ($conf_UAM[2] <> -1)
+			{
+				$query = "
+DELETE FROM ".USER_GROUP_TABLE."
+WHERE user_id = '".$data['user_id']."'
+  AND group_id = '".$conf_UAM[2]."'
+;";
+				pwg_query($query);
+			}
+  
 			if ($conf_UAM[3] <> -1)
 			{
@@ -668,14 +746,4 @@
 WHERE user_id = '".$data['user_id']."'
   AND group_id = '".$conf_UAM[3]."'
-;";
-				pwg_query($query);
-			}
-  
-			if ($conf_UAM[4] <> -1)
-			{
-				$query = "
-DELETE FROM ".USER_GROUP_TABLE."
-WHERE user_id = '".$data['user_id']."'
-  AND group_id = '".$conf_UAM[4]."'
 				;";
 				pwg_query($query);
@@ -685,14 +753,14 @@
   (user_id, group_id)
 VALUES
-  ('".$data['user_id']."', '".$conf_UAM[4]."')
+  ('".$data['user_id']."', '".$conf_UAM[3]."')
 ;";
 				pwg_query($query);
 			}
 
-			if (($conf_UAM[5] <> -1 or isset($data['status'])))
+			if (($conf_UAM[4] <> -1 or isset($data['status'])))
 			{
 				$query = "
 UPDATE ".USER_INFOS_TABLE."
-SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[5])."'
+SET status = '".(isset($data['status']) ? $data['status'] : $conf_UAM[4])."'
 WHERE user_id = '".$data['user_id']."'
 ;";
@@ -706,28 +774,4 @@
 }
 
-/* Function called from main.inc.php - Get username case insensitive */
-function NotSensibleSearchUsername($username)
-{
-  global $conf;
-  
-  if (isset($username))
-  {
-    $query = "
-SELECT ".$conf['user_fields']['username']."
-FROM ".USERS_TABLE."
-WHERE LOWER(".stripslashes($conf['user_fields']['username']).") = '".strtolower($username)."'
-;";
-    $users = pwg_db_num_rows(pwg_query($query));
-    if ($users > 0)
-    {
-      return true;
-    }
-    else
-    {
-      return false;
-    }
-  }
-}
-
 
 /* Function called from main.inc.php - Check if username matches forbidden caracters */
@@ -738,7 +782,7 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
 
-  if (isset($login) and isset($conf_UAM[8]) and $conf_UAM[8] <> '')
-  {
-    $conf_CharExclusion = preg_split("/,/",$conf_UAM[8]);
+  if (isset($login) and isset($conf_UAM[7]) and $conf_UAM[7] <> '')
+  {
+    $conf_CharExclusion = preg_split("/,/",$conf_UAM[7]);
     for ($i = 0 ; $i < count($conf_CharExclusion) ; $i++)
     {
@@ -765,8 +809,8 @@
   $conf_UAM = unserialize($conf['UserAdvManager']);
   
-	if (isset($email) and isset($conf_UAM[13]) and $conf_UAM[13] <> '')
+	if (isset($email) and isset($conf_UAM[12]) and $conf_UAM[12] <> '')
 	{
 		//$ncsemail = strtolower($email);
-		$conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM[13]);
+		$conf_MailExclusion = preg_split("/[\s,]+/",$conf_UAM[12]);
 		for ($i = 0 ; $i < count($conf_MailExclusion) ; $i++)
 		{
@@ -816,21 +860,21 @@
   OR TO_DAYS(NOW()) - TO_DAYS(ui.registration_date) < "'.$conf_UAM_ConfirmMail[1].'")';
 
-	if ($conf_UAM[3] <> '-1' and $conf_UAM[9] == '-1')
+	if ($conf_UAM[2] <> '-1' and $conf_UAM[8] == '-1')
   {
     $query.= '
-  AND ug.group_id = '.$conf_UAM[3];
-  }
-  if ($conf_UAM[3] == '-1' and $conf_UAM[9] <> '-1')
+  AND ug.group_id = '.$conf_UAM[2];
+  }
+  if ($conf_UAM[2] == '-1' and $conf_UAM[8] <> '-1')
   {
     $query.= '
-  AND ui.status = \''.$conf_UAM[9]."'";
-  }
-  if ($conf_UAM[3] <> '-1' and $conf_UAM[9] <> '-1')
+  AND ui.status = \''.$conf_UAM[8]."'";
+  }
+  if ($conf_UAM[2] <> '-1' and $conf_UAM[8] <> '-1')
   {
     $query.= '
-  AND ug.group_id = \''.$conf_UAM[3]."'";
+  AND ug.group_id = \''.$conf_UAM[2]."'";
   }
   $query.= '
-ORDER BY id ASC
+ORDER BY ui.registration_date ASC
 ;';
 
@@ -896,6 +940,6 @@
   INNER JOIN '.USER_LASTVISIT_TABLE.' AS lv
     ON u.'.$conf['user_fields']['id'].' = lv.user_id
-WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM[18].'")
-ORDER BY id ASC;';
+WHERE (TO_DAYS(NOW()) - TO_DAYS(lv.lastvisit) >= "'.$conf_UAM[17].'")
+ORDER BY lv.lastvisit ASC;';
 
 	$result = pwg_query($query);
@@ -937,5 +981,5 @@
     ON u.'.$conf['user_fields']['id'].' = ug.user_id
 WHERE u.'.$conf['user_fields']['id'].' >= 3
-ORDER BY lastvisit DESC
+ORDER BY ug.lastvisit DESC
 ;';
 
@@ -1002,5 +1046,5 @@
 		else
 		{
-			return True;
+			return true;
 		}
 	}
@@ -1168,3 +1212,32 @@
   }
 }
+
+
+// check_consult - Thx to LucMorizur
+// checks if a user id is registered as having already
+// visited his profile.php page.
+// @uid        : the user id
+// @user_idsOK : (returned) array of all users ids having already visited
+//               their profile.php pages
+//
+// @returns    : true or false whether the users has already visited his
+//               profile.php page or not
+function check_consult($uid, &$user_idsOK)
+{
+  $t = array();
+  $v = false;
+  
+  $query = "
+SELECT value
+FROM ".CONFIG_TABLE."
+WHERE param = 'UserAdvManager_Redir'
+;";
+  
+  if ($v = (($t = pwg_db_fetch_row(pwg_query($query))) !== false))
+  {
+    $user_idsOK = explode(',', $t[0]);
+    $v = (in_array($uid, $user_idsOK));
+  }
+  return $v;
+}
 ?>
